<?php
class ControllerExtensionModuleRoutee extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$resultJson = $this->getAuthenticate($this->request->post);
			
			if(!isset($resultJson))
			{
				$this->session->data['warning'] = 'The usename or password in incorrect. Visit <a href="https://go.routee.net">https://go.routee.net</a> to create your account and try again.';
				$this->response->redirect($this->url->link('extension/module/routee', 'user_token=' . $this->session->data['user_token'], true));
			}
			else
			{
				if(isset($resultJson['message']) && ($resultJson['message'] == "Authorization succeed"))
				{
					$module_routee_uuid = $this->config->get('module_routee_uuid');	
					if($module_routee_uuid == "")
					{
						$this->request->post['module_routee_uuid'] = $resultJson['uuid'];
					}
					
					$this->model_setting_setting->editSetting('module_routee', $this->request->post);
					
					$this->session->data['success'] = $this->language->get('text_success');

					$this->response->redirect($this->url->link('extension/module/routee', 'user_token=' . $this->session->data['user_token'], true));
				}
				else
				{
					$this->session->data['warning'] = 'The usename or password in incorrect. Visit <a href="https://go.routee.net">https://go.routee.net</a> to create your account and try again.';
					$this->response->redirect($this->url->link('extension/module/routee', 'user_token=' . $this->session->data['user_token'], true));
				}
			}
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
		if (isset($this->session->data['warning'])) {
			$data['error_warning'] = $this->session->data['warning'];
			unset($this->session->data['warning']);
		} else {
			$data['error_warning'] = '';
		}
		
		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->error['username'])) {
			$data['error_username'] = $this->error['username'];
		} else {
			$data['error_username'] = '';
		}
		
		if (isset($this->error['password'])) {
			$data['error_password'] = $this->error['password'];
		} else {
			$data['error_password'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/module/routee', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		if (isset($this->request->post['module_routee_status'])) {
			$data['module_routee_status'] = $this->request->post['module_routee_status'];
		} else {
			$data['module_routee_status'] = $this->config->get('module_routee_status');
		}
		
		if (isset($this->request->post['module_routee_username'])) {
			$data['module_routee_username'] = $this->request->post['module_routee_username'];
		} else {
			$data['module_routee_username'] = $this->config->get('module_routee_username');
		}
		
		if (isset($this->request->post['module_routee_password'])) {
			$data['module_routee_password'] = $this->request->post['module_routee_password'];
		} else {
			$data['module_routee_password'] = $this->config->get('module_routee_password');
		}
		
		if (isset($this->request->post['module_routee_uuid'])) {
			$data['module_routee_uuid'] = $this->request->post['module_routee_uuid'];
		} else {
			$data['module_routee_uuid'] = $this->config->get('module_routee_uuid');
		}
		
		// Limit
		if (isset($this->request->post['module_routee_customer_limit'])) {
			$data['module_routee_customer_limit'] = $this->request->post['module_routee_customer_limit'];
		} else if ($this->config->get('module_routee_customer_limit')) {
			$data['module_routee_customer_limit'] = $this->config->get('module_routee_customer_limit');
		} else {
			$data['module_routee_customer_limit'] = 1;
		}
		
		if (isset($this->request->post['module_routee_newsletter_limit'])) {
			$data['module_routee_newsletter_limit'] = $this->request->post['module_routee_newsletter_limit'];
		} else if ($this->config->get('module_routee_newsletter_limit')) {
			$data['module_routee_newsletter_limit'] = $this->config->get('module_routee_newsletter_limit');
		} else {
			$data['module_routee_newsletter_limit'] = 1;
		}
		
		if (isset($this->request->post['module_routee_order_limit'])) {
			$data['module_routee_order_limit'] = $this->request->post['module_routee_order_limit'];
		} else if ($this->config->get('module_routee_order_limit')) {
			$data['module_routee_order_limit'] = $this->config->get('module_routee_order_limit');
		} else {
			$data['module_routee_order_limit'] = 1;
		}
		
		if (isset($this->request->post['module_routee_product_limit'])) {
			$data['module_routee_product_limit'] = $this->request->post['module_routee_product_limit'];
		} else if ($this->config->get('module_routee_product_limit')) {
			$data['module_routee_product_limit'] = $this->config->get('module_routee_product_limit');
		} else {
			$data['module_routee_product_limit'] = 1;
		}
		
		if (isset($this->request->post['module_routee_wishlist_limit'])) {
			$data['module_routee_wishlist_limit'] = $this->request->post['module_routee_wishlist_limit'];
		} else if ($this->config->get('module_routee_wishlist_limit')) {
			$data['module_routee_wishlist_limit'] = $this->config->get('module_routee_wishlist_limit');
		} else {
			$data['module_routee_wishlist_limit'] = 1;
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee', $data));
	}
	
	public function uninstall() {
        try {
            $this->sendLogs('event triggered', 'event', 'Uninstall');

            if($this->config->get('module_routee_uuid') != "")
            {
                $customerCartValue = array();

                $customerCartValue['data'] = array();
                $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
                $customerCartValue["event"] = 'Uninstall';

                $postData = json_encode($customerCartValue);
                $this->sendLogs('event before api call', 'events', 'Uninstall');
                $ch = curl_init('https://idata.routee.net/api/event');
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $result = curl_exec($ch);
                $this->sendLogs('event after api call', 'event', 'Uninstall');
                $this->load->library('routee');
                $this->routee->write("Uninstall: ".json_encode($customerCartValue)." Result: ".$result);

                $resultJson = json_decode($result, 1);
            }

        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'events', 'Uninstall', $exception);
        }
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/routee')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		// Check Response
		if (!$this->request->post['module_routee_username']) {
			$this->error['username'] = $this->language->get('error_username');
		}

		if (!$this->request->post['module_routee_password']) {
			$this->error['password'] = $this->language->get('error_password');
		}
		

		return !$this->error;
	}
	
	public function getAuthenticate($post) {
		$this->load->model('setting/modification');
		$plugin_data = $this->model_setting_modification->getModificationByCode('Routee API');

        try {
            $this->sendLogs('event triggered', 'auth', 'Auth');
            $postData = [
                "username" => $post['module_routee_username'],
                "password" => $post['module_routee_password'],
                "source" => "Opencart",
                "type" => "E-Commerce",
                "version" => VERSION,
                "plugin_version" => $plugin_data['version'],
                "domain" => HTTP_CATALOG
            ];

            $data_string = json_encode($postData);
            $this->sendLogs('event before api call', 'auth', 'Auth');
            $ch = curl_init('https://api.waymore.io/api/authenticate');
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Content-Length: ' . strlen($data_string))
            );
            $result = curl_exec($ch);
            $resultJson = json_decode($result, 1);
            $this->sendLogs('event after api call', 'auth', 'Auth');
            return $resultJson;
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'auth', 'Auth', $exception);
        }
	}
	
	public function massProductInsert() {

        try {
            $this->sendLogs('event triggered', 'massdata', 'Product Export');
            $this->load->model('catalog/product');
            $this->load->model('catalog/category');
            $sort = 'pd.name';
            $order = 'ASC';
            $page = '1';

            $filter_data_total = array();
            $product_total = $this->model_catalog_product->getTotalProducts($filter_data_total);

            $filter_data = array(
                'filter_name'	  => '',
                'filter_model'	  => '',
                'filter_price'	  => '',
                'filter_quantity' => '',
                'filter_status'   => '',
                'sort'            => $sort,
                'order'           => $order,
                'start'           => 0,
                'limit'           => $this->config->get('config_limit_admin')
            );


            $productData = $this->model_catalog_product->getProducts($filter_data);

            $success = $failed = $not_exist = 0;

            if($this->config->get('module_routee_uuid') != "")
            {
                $resultJson = array();
                $customerCartValue = $productInfo = array();

                if($productData)
                {
                    $count = 0;
                    foreach($productData as $k => $productRow)
                    {
                        $searchProduct = array();

                        $special = false;

                        $product_specials = $this->model_catalog_product->getProductSpecials($productRow['product_id']);

                        foreach ($product_specials  as $product_special) {
                            if (($product_special['date_start'] == '0000-00-00' || strtotime($product_special['date_start']) < time()) && ($product_special['date_end'] == '0000-00-00' || strtotime($product_special['date_end']) > time())) {
                                $special = $product_special['price'];

                                break;
                            }
                        }


                        $category = array();

                        $categories = $this->model_catalog_product->getProductCategories($productRow['product_id']);

                        foreach ($categories as $category_id) {
                            $category_info = $this->model_catalog_category->getCategory($category_id);

                            if ($category_info) {
                                $category[] = $category_info['name'];
                            }
                        }

                        $image_link = $product_link = "";

                        if (isset($productRow['image'])) {
                            $image_link = HTTP_CATALOG.$productRow['image'];
                        }

                        $product_link = HTTP_CATALOG.'index.php?route=product/product&product_id='.$productRow['product_id'];

                        $discount = array();

                        $product_discounts = $this->model_catalog_product->getProductDiscounts($productRow['product_id']);

                        foreach ($product_discounts as $product_discount) {
                            $discount[] = array(
                                'price'             => $this->tax->calculate($product_discount['price'], $productRow['tax_class_id'], $this->config->get('config_tax')),
                                'quantity'          => $product_discount['quantity'],
                                'date_start'        => ($product_discount['date_start'] != '0000-00-00') ? $product_discount['date_start'] : '',
                                'date_end'          => ($product_discount['date_end'] != '0000-00-00') ? $product_discount['date_end'] : ''
                            );
                        }

                        $product_description = $this->model_catalog_product->getProductDescriptions($productRow['product_id']);

                        if($special)
                        {
                            $price = $special;
                        }
                        else
                        {
                            $price = $productRow['price'];
                        }

                        foreach ($product_description as $language_id => $value) {
                            $searchProduct = array('product_id' => $productRow['product_id'], 'name' => $value['name'], 'description' => html_entity_decode($value['description'], ENT_QUOTES, 'UTF-8'), 'categories' => $category, 'stock_quantity' => $productRow['quantity'], 'price' => $this->tax->calculate($price, $productRow['tax_class_id'], $this->config->get('config_tax')), 'discount' => $discount, 'image_link' => $image_link, 'product_link' => $product_link);
                        }
                        $productInfo[] = $searchProduct;
                    }

                    $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');


                    $customerCartValue['data'][0]["name"] = 'Products';
                    $customerCartValue['data'][0]["description"] = 'Products Opencart 3.0.2.0';
                    $customerCartValue['data'][0]['object'] = $productInfo;

                    $postData = json_encode($customerCartValue);
                    $this->sendLogs('event before api call', 'massdata', 'Product Export');
                    $ch = curl_init('https://idata.routee.net/api/data');
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $result = curl_exec($ch);

                    $this->load->library('routee');
                    $this->routee->write("Mass Products: ".json_encode($customerCartValue)." Result: ".$result);
                    $this->sendLogs('event after api call', 'massdata', 'Product Export');
                    $resultJson = json_decode($result, 1);

                    if(isset($resultJson))
                    {
                        /* Made changes in below code which was checking for exact message but in case changed in message or something then will create issue
                        * So it's good to check for array emptyness instead. Old one is "$resultJson['message'] == "Valid Data""
                        * On 26th Feb 2020
                        * By : Kapil Hanswal
                        */
                        if(!empty($resultJson['message']))
                        {
                            $this->session->data['success'] = $this->language->get('text_success');
                        }
                        else
                        {
                            $this->session->data['error_warning'] = $this->language->get('text_error');
                        }
                    }
                    else
                    {
                        $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                    }
                }
                else
                {
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $not_exist++;
                }
            }

            $counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'massdata', 'Product Export', $exception);
        }


	}
	
	public function massCustomerInsert() {

        try {
            $this->sendLogs('event triggered', 'massdata', 'Customer Export');
            $this->load->model('customer/customer');
            $this->load->model('extension/module/customer_cart');

            $sort = 'name';
            $order = 'ASC';
            $page = '1';

            $filter_data_total = array();
            $customer_total = $this->model_customer_customer->getTotalCustomers($filter_data_total);

            $filter_data = array(
                'filter_name'              => '',
                'filter_email'             => '',
                'filter_customer_group_id' => '',
                'filter_status'            => '',
                'filter_date_added'        => '',
                'filter_ip'                => '',
                'sort'                     => $sort,
                'order'                    => $order,
                'start'                    => 0,
                'limit'                    => $this->config->get('config_limit_admin')
            );

            $customerData = $this->model_customer_customer->getCustomers($filter_data);

            $success = $failed = $not_exist = 0;

            if($this->config->get('module_routee_uuid') != "")
            {
                $resultJson = array();
                $customerCartValue = $customerInfo = array();

                if($customerData)
                {
                    $count = 0;
                    foreach($customerData as $k => $customerRow)
                    {
                        $customerRow['id'] = $customerRow['customer_id'];
                        $customerRow['phone'] = $customerRow['telephone'];

                        unset($customerRow['cart']);
                        $customerCartData = $this->model_extension_module_customer_cart->getCart($customerRow['customer_id']);

                        $customerCart = array();
                        if($customerCartData)
                        {
                            foreach($customerCartData as $k => $cartData)
                            {
                                $customerCart['cart_products'][] = array('product_id' => $cartData['product_id'], 'option' => $cartData['option'], 'quantity' => $cartData['quantity']);
                            }
                        }
                        //$customerRow['cart'] = $customerCart;

                        // Address Data
                        $customerAddressData = $this->model_customer_customer->getAddresses($customerRow['customer_id']);

                        $customerAddress = array();
                        if($customerAddressData)
                        {
                            foreach($customerAddressData as $k => $cartAddressRow)
                            {
                                $cartAddressRow['address1'] = $cartAddressRow['address_1'];
                                $cartAddressRow['address2'] = $cartAddressRow['address_2'];

                                unset($cartAddressRow['address_1']);
                                unset($cartAddressRow['address_2']);
                                $customerAddress[] = $cartAddressRow;
                            }
                        }
                        //$customerRow['addresses'] = $customerAddress;

                        unset($customerRow['customer_id']);
                        unset($customerRow['telephone']);
                        $customerInfo[] = array('customer' => $customerRow, 'cart' => $customerCart, 'addresses' => $customerAddress);
                        //$customerInfo[]['customer'] = $customerRow;
                    }

                    $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');


                    $customerCartValue['data'][0]["name"] = 'Customers';
                    $customerCartValue['data'][0]["description"] = 'Customers Opencart 3.0.2.0';
                    $customerCartValue['data'][0]['object'] = $customerInfo;

                    $postData = json_encode($customerCartValue);

                    $this->sendLogs('event before api call', 'massdata', 'Customer Export');
                    $ch = curl_init('https://idata.routee.net/api/data');
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $result = curl_exec($ch);

                    $this->load->library('routee');
                    $this->routee->write("Mass Customers: ".json_encode($customerCartValue)." Result: ".$result);
                    $this->sendLogs('event after api call', 'massdata', 'Customer Export');
                    $resultJson = json_decode($result, 1);

                    if(isset($resultJson))
                    {
                        /* Made changes in below code which was checking for exact message but in case changed in message or something then will create issue
                        * So it's good to check for array emptyness instead. Old one is "$resultJson['message'] == "Valid Data""
                        * On 26th Feb 2020
                        * By : Kapil Hanswal
                        */
                        if(!empty($resultJson['message']))
                        {
                            $this->session->data['success'] = $this->language->get('text_success');
                        }
                        else
                        {
                            $this->session->data['error_warning'] = $this->language->get('text_error');
                        }
                    }
                    else
                    {
                        $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                    }
                }
                else
                {
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $not_exist++;
                }
            }

            $counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);

            if($failed > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_error');
            }
            else if($not_exist > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
            }
            else
            {
                $this->session->data['success'] = $this->language->get('text_success');
            }
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'massdata', 'Customer Export', $exception);
        }


	}
	
	public function massOrderInsert() {
        try {
            $this->sendLogs('event triggered', 'massdata', 'Order Export');
            $this->load->model('sale/order');
            $sort = 'o.order_id';
            $order = 'DESC';
            $page = '1';

            $filter_data_total = array();
            $order_total = $this->model_sale_order->getTotalOrders($filter_data_total);

            $filter_data = array(
                'filter_order_id'        => '',
                'filter_customer'	     => '',
                'filter_order_status'    => '',
                'filter_order_status_id' => '',
                'filter_total'           => '',
                'filter_date_added'      => '',
                'filter_date_modified'   => '',
                'sort'            => $sort,
                'order'           => $order,
                'start'                    => 0,
                'limit'                    => $this->config->get('config_limit_admin')
            );


            $orderData = $this->model_sale_order->getOrders($filter_data);

            $success = $failed = $not_exist = 0;

            if($this->config->get('module_routee_uuid') != "")
            {
                $resultJson = array();
                $customerCartValue = $orderInfo = array();

                if($orderData)
                {
                    $resultJson = array();
                    foreach($orderData as $k => $orderRow)
                    {
                        $order = array();

                        $order_info = $this->model_sale_order->getOrder($orderRow['order_id']);
                        if($order_info)
                        {
                            $order['order_details'] = array('customer_id' => $order_info['customer_id'], 'order_id' => $order_info['order_id'], 'order_status' => $order_info['order_status'], 'shipping_method' => $order_info['shipping_method'], 'payment_method' => $order_info['payment_method'], 'total_price' => $order_info['total']);
                        }

                        $order_products = array();
                        $products = $this->model_sale_order->getOrderProducts($orderRow['order_id']);

                        foreach ($products as $product) {
                            $order_products[] = array(
                                'product_id' => $product['product_id'],
                                'quantity'   => $product['quantity'],
                            );
                        }

                        $order['order_products'] = $order_products;

                        $orderInfo[] = $order;
                    }

                    $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');


                    $customerCartValue['data'][0]["name"] = 'Orders';
                    $customerCartValue['data'][0]["description"] = 'Shop Orders Opencart 3.0.2.0';
                    $customerCartValue['data'][0]['object'] = $orderInfo;

                    $postData = json_encode($customerCartValue);

                    $this->sendLogs('event before api call', 'massdata', 'Order Export');
                    $ch = curl_init('https://idata.routee.net/api/data');
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $result = curl_exec($ch);

                    $this->load->library('routee');
                    $this->routee->write("Mass Orders: ".json_encode($customerCartValue)." Result: ".$result);
                    $this->sendLogs('event after api call', 'massdata', 'Order Export');
                    $resultJson = json_decode($result, 1);

                    if(isset($resultJson))
                    {
                        /* Made changes in below code which was checking for exact message but in case changed in message or something then will create issue
                        * So it's good to check for array emptyness instead. Old one is "$resultJson['message'] == "Valid Data""
                        * On 26th Feb 2020
                        * By : Kapil Hanswal
                        */
                        if(!empty($resultJson['message']))
                        {
                            $this->session->data['success'] = $this->language->get('text_success');
                        }
                        else
                        {
                            $this->session->data['error_warning'] = $this->language->get('text_error');
                        }
                    }
                    else
                    {
                        $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                        $failed++;
                    }
                }
                else
                {
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $not_exist++;
                }
            }

            $counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);

            if($failed > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_error');
            }
            else if($not_exist > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
            }
            else
            {
                $this->session->data['success'] = $this->language->get('text_success');
            }
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'massdata', 'Order Export', $exception);
        }

	}
	
	public function massWishlistInsert() {

        try {
            $this->sendLogs('event triggered', 'massdata', 'Wishlist Export');
            $this->load->model('customer/customer');
            $this->load->model('extension/module/customer_wishlist');
            $sort = 'name';
            $order = 'ASC';
            $page = '1';

            $filter_data_total = array();
            $customer_total = $this->model_customer_customer->getTotalCustomers($filter_data_total);

            $filter_data = array(
                'filter_name'              => '',
                'filter_email'             => '',
                'filter_customer_group_id' => '',
                'filter_status'            => '',
                'filter_date_added'        => '',
                'filter_ip'                => '',
                'sort'                     => $sort,
                'order'                    => $order,
                'start'                    => 0,
                'limit'                    => $this->config->get('config_limit_admin')
            );
            $customerData = $this->model_customer_customer->getCustomers($filter_data);

            $customerWishlist = $this->model_extension_module_customer_wishlist->getAllWishlist();

            $success = $failed = $not_exist = 0;

            if($this->config->get('module_routee_uuid') != "")
            {
                $resultJson = array();
                $customerCartValue = $wishlistInfo = array();

                if($customerData && $customerWishlist)
                {
                    foreach($customerData as $k => $customerRow)
                    {
                        $customerID = $customerRow['customer_id'];

                        $customerWishlistData = $this->model_extension_module_customer_wishlist->getWishlist($customerID);
                        if($customerWishlistData)
                        {
                            foreach($customerWishlistData as $k1 => $customerWishlistRow)
                            {
                                unset($customerWishlistRow['date_added']);
                                $wishlistInfo[] = $customerWishlistRow;
                            }
                        }
                    }

                    $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');


                    $customerCartValue['data'][0]["name"] = 'Wishlist';
                    $customerCartValue['data'][0]["description"] = 'Wishlist Description Opencart 3.0.2.0';
                    $customerCartValue['data'][0]['object'] = $wishlistInfo;

                    $postData = json_encode($customerCartValue);
                    $this->sendLogs('event before api call', 'massdata', 'Wishlist Export');
                    $ch = curl_init('https://idata.routee.net/api/data');
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $result = curl_exec($ch);


                    $this->load->library('routee');
                    $this->routee->write("Mass Wishlist: ".json_encode($customerCartValue)." Result: ".$result);
                    $this->sendLogs('event after api call', 'massdata', 'Wishlist Export');
                    $resultJson = json_decode($result, 1);

                    if(isset($resultJson))
                    {
                        /* Made changes in below code which was checking for exact message but in case changed in message or something then will create issue
                        * So it's good to check for array emptyness instead. Old one is "$resultJson['message'] == "Valid Data""
                        * On 26th Feb 2020
                        * By : Kapil Hanswal
                        */
                        if(!empty($resultJson['message']))
                        {
                            $this->session->data['success'] = $this->language->get('text_success');
                        }
                        else
                        {
                            $this->session->data['error_warning'] = $this->language->get('text_error');
                        }
                    }
                    else
                    {
                        $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                        $failed++;
                    }
                }
                else
                {
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $not_exist++;
                }
            }

            $counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);

            if($failed > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_error');
            }
            else if($not_exist > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
            }
            else
            {
                $this->session->data['success'] = $this->language->get('text_success');
            }
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'massdata', 'Wishlist Export', $exception);
        }
	}
	
	public function massNewsletterSubscribeInsert() {
        try {
            $this->sendLogs('event triggered', 'massdata', 'Newsletter Subscribers');
            $this->load->model('customer/customer');
            $sort = 'name';
            $order = 'ASC';
            $page = '1';

            $filter_data_total = array('filter_newsletter'		   => '1');
            $customer_total = $this->model_customer_customer->getTotalCustomers($filter_data_total);

            $filter_data = array(
                'filter_name'              => '',
                'filter_email'             => '',
                'filter_customer_group_id' => '',
                'filter_status'            => '',
                'filter_date_added'        => '',
                'filter_ip'                => '',
                'filter_newsletter'		   => '1',
                'sort'                     => $sort,
                'order'                    => $order,
                'start'                    => 0,
                'limit'                    => $this->config->get('config_limit_admin')
            );

            $customerData = $this->model_customer_customer->getCustomers($filter_data);

            $success = $failed = $not_exist = 0;

            if($this->config->get('module_routee_uuid') != "")
            {
                $resultJson = array();
                $customerCartValue = $customerInfo = array();

                if($customerData)
                {
                    $count = 0;
                    foreach($customerData as $k => $customerRow)
                    {
                        $customerInfo[] = array('email' => $customerRow['email']);
                    }

                    $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');


                    $customerCartValue['data'][0]["name"] = 'Newsletter Subscribers';
                    $customerCartValue['data'][0]["description"] = 'Newsletter Subscribers Opencart 3.0.2.0';
                    $customerCartValue['data'][0]['object'] = $customerInfo;

                    $postData = json_encode($customerCartValue);
                    $this->sendLogs('event before api call', 'massdata', 'Newsletter Subscribers');
                    $ch = curl_init('https://idata.routee.net/api/data');
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $result = curl_exec($ch);
                    $this->sendLogs('event after api call', 'massdata', 'Newsletter Subscribers');
                    $this->load->library('routee');
                    $this->routee->write("Mass Newsletter Subscribers: ".json_encode($customerCartValue)." Result: ".$result);

                    $resultJson = json_decode($result, 1);

                    if(isset($resultJson))
                    {
                        /* Made changes in below code which was checking for exact message but in case changed in message or something then will create issue
                        * So it's good to check for array emptyness instead. Old one is "$resultJson['message'] == "Valid Data""
                        * On 26th Feb 2020
                        * By : Kapil Hanswal
                        */
                        if(!empty($resultJson['message']))
                        {
                            $this->session->data['success'] = $this->language->get('text_success');
                        }
                        else
                        {
                            $this->session->data['error_warning'] = $this->language->get('text_error');
                        }
                    }
                    else
                    {
                        $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                        $failed++;
                    }
                }
                else
                {
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $not_exist++;
                }
            }

            $counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);


            if($failed > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_error');
            }
            else if($not_exist > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
            }
            else
            {
                $this->session->data['success'] = $this->language->get('text_success');
            }
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), 'massdata', 'Newsletter Subscribers', $exception);
        }
	}


    public function sendLogs($message, $event, $logType, $excep=null)
    {

        try {
            $this->load->library('routeelogs');
            $this->routeelogs->saveLogs($logType,$event, $message, $excep);
        }catch (Exception $exception){}

    }


}
