<?php
class ControllerExtensionModuleRouteeExportlogs extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/exportlogs');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title');
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }

		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/exportlogs', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		
		
		$data['oken'] = $this->session->data['user_token'];

        $data['export_logs_as_csv'] = $this->url->link('extension/module/routee/exportlogs/export_logs_as_csv', 'user_token=' . $this->session->data['user_token'], true);
        $data['export_logs'] = $this->url->link('extension/module/routee/exportlogs/export_logs', 'user_token=' . $this->session->data['user_token'], true);

		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/customers/insert_mass', 'user_token=' . $this->session->data['user_token'], true));

		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/logsexport', $data));
	}
	
	public function export_logs_as_csv() {
        try {
            $result = [];
            $user_token  = $_GET['user_token'];
            if ( $this->session->data['user_token'] != $user_token) {
                $this->session->data['error_warning'] = $this->language->get('text_auth_error');
                $result = array(
                    'error' => 1
                );
            } else {
                $result = $this->db->query("SELECT * FROM ".DB_PREFIX."routee_shop_logs WHERE is_exported='0'");
                $result = $result->rows;
            }
            echo json_encode($result);
            exit;
        }catch (Exception $exception){}
	}

    function eventName($eventType) {
        $name = '';

        switch ($eventType) {
            case 1:
                $name = "auth";
                break;
            case 3:
                $name = "massdata";
                break;
            case 2:
                $name = "events";
                break;
        }

        return $name;
    }

    public function export_logs() {
        try {
            $user_token  = $_GET['user_token'];
            $uuid = $this->config->get('module_routee_uuid');
            if ( $this->session->data['user_token'] != $user_token || empty($uuid)) {
                $this->session->data['error_warning'] = $this->language->get('text_auth_error');
                $result = array(
                    'error' => 1
                );
            } else {
                $result = $this->db->query("SELECT * FROM ".DB_PREFIX."routee_shop_logs WHERE is_exported='0'");
                $result = $result->rows;
                if (count($result)){
                    $postArr = $ids = [];
                    $resArr = $result;
                    $count = count($resArr);
                    if ( $count > 0 ) {
                        $shop = $this->config->get('config_url');
                        foreach ($resArr as $key => $log) {
                            $ids[] = $log['id'];
                            $postArr[] = array(
                                'siteUrl' => $shop,
                                'uuid' => $uuid,
                                'event_name' => $this->eventName($log['event_type']),
                                'log_type' => $log['log_type'] == 1 ? 'success' : 'failure',
                                'log_data' => $log['log_data'],
                                'created_at' => $log['created_at'],
                                'platform' => "OpenCartv3"
                            );
                        }
                        $ch = curl_init('https://autoforms.routee.net/u001/log.php?multi=1');
                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postArr));
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        $result = curl_exec($ch);
                        $qry = "UPDATE ".DB_PREFIX."routee_shop_logs SET is_exported='1' WHERE is_exported='0' AND id IN (".implode(',',$ids).")";
                        $this->db->query($qry);
                        $result = [
                            'success' => 1
                        ];
                    }
                }

            }
            echo json_encode($result);
            exit;
        }catch (Exception $exception){}
    }
}
