<?php
class ControllerExtensionModuleRouteeWishlist extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/wishlist');

		$this->document->setTitle($this->language->get('heading_title'));
		
		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/wishlist', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		
		$this->load->model('customer/customer');
		$this->load->model('extension/module/customer_wishlist');
		$sort = 'name';
		$order = 'ASC';
		$module_routee_wishlist_limit = $this->config->get('module_routee_wishlist_limit');
		if($module_routee_wishlist_limit <= 0)
		{
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_wishlist_limit', 1);
		}
		
		$filter_data = array(
			'filter_name'              => '',
			'filter_email'             => '',
			'filter_customer_group_id' => '',
			'filter_status'            => '',
			'filter_date_added'        => '',
			'filter_ip'                => '',
			'sort'                     => $sort,
			'order'                    => $order,
			'start'          		   => ($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           		   => $this->config->get('config_limit_admin')
		);
		$customerData = $this->model_customer_customer->getCustomers($filter_data);
		
		$customerWishlist = $this->model_extension_module_customer_wishlist->getAllWishlist();
		$customer_count = count($customerData);
		
		if(($customer_count == 0) && ($customer_count < $this->config->get('config_limit_admin')))
		{
			foreach($customerData as $k => $customerRow)
			{
				$customerID = $customerRow['customer_id'];
				
				$customerWishlistData = $this->model_extension_module_customer_wishlist->getWishlist($customerID);
				if($customerWishlistData)
				{
					$data['wishlist_exists'] = 1;
				}
				else
				{
					$data['wishlist_exists'] = 1;
				}
			}
		}
		else
		{
			$data['product_exists'] = 0;
		}
		
		$data['user_token'] = $this->session->data['user_token'];
		
		$data['insert'] = $this->url->link('extension/module/routee/wishlist/insert', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/wishlist/insert_mass', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/wishlist/insert_mass', 'user_token=' . $this->session->data['user_token'], true));
		
		// Wishlist config
		$module_routee_wishlist_limit = $this->config->get('module_routee_wishlist_limit');
		$data['module_routee_wishlist_limit'] = $module_routee_wishlist_limit;
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/wishlist', $data));
		
		//$resultCustomer = $this->insertCustomerData();
		//print_r($resultCustomer); exit;
	}
	
	public function insert() {
		$this->load->language('extension/module/routee/wishlist');
		
		$this->load->model('customer/customer');
		$this->load->model('extension/module/customer_wishlist');
		$sort = 'name';
		$order = 'ASC';
		$page = '1';
		
		$filter_data = array(
			'filter_name'              => '',
			'filter_email'             => '',
			'filter_customer_group_id' => '',
			'filter_status'            => '',
			'filter_date_added'        => '',
			'filter_ip'                => '',
			'filter_newsletter'		   => '1',
			'sort'                     => $sort,
			'order'                    => $order,
			'start'                    => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'                    => $this->config->get('config_limit_admin')
		);
		
		$customerData = $this->model_customer_customer->getCustomers($filter_data);
		$customerWishlist = $this->model_extension_module_customer_wishlist->getAllWishlist();
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			if($customerData && $customerWishlist)
			{
				$resultJson = array();
				foreach($customerData as $k => $customerRow)
				{
					$customerID = $customerRow['customer_id'];
					
					$customerWishlistData = $this->model_extension_module_customer_wishlist->getWishlist($customerID);
					if($customerWishlistData)
					{
						foreach($customerWishlistData as $k1 => $customerWishlistRow)
						{
							$customerCartValue = array();
							
							$customerCartValue['data'] = $customerWishlistRow;
							$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
							$customerCartValue["event"] = 'Wishlist';
							
							$postData = json_encode($customerCartValue);
				
							$ch = curl_init('https://idata.routee.net/api/event');                                                                      
							curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
							curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
							curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
							$result = curl_exec($ch);
							
							$this->load->library('routee');
							$this->routee->write("Event Wishlist: ".json_encode($customerCartValue)." Result: ".$result);
							
							$resultJson[$k1] = json_decode($result, 1);
						}
					}
				}
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					foreach($resultJson as $k => $message)
					{
						if($message['message'] == "Valid Data")
						{
							$this->session->data['success'] = $this->language->get('text_success');
							$success++;
						}
						else
						{
							$this->session->data['error_warning'] = $this->language->get('text_error');
							$failed++;
						}
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
					$failed++;
				}
			}
			else
			{
				$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['wishlist_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = $this->language->get('text_success');
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/wishlist', 'user_token=' . $this->session->data['user_token'], true));
	}
	
	public function insert_mass() {
        try {
            $this->sendLogs('event triggered');
            $this->load->language('extension/module/routee/wishlist');

            $this->load->model('customer/customer');
            $this->load->model('extension/module/customer_wishlist');
            $sort = 'name';
            $order = 'ASC';
            $module_routee_wishlist_limit = $this->config->get('module_routee_wishlist_limit');

            $filter_data_total = array();
            $customer_total = $this->model_customer_customer->getTotalCustomers($filter_data_total);

            $filter_data = array(
                'filter_name'              => '',
                'filter_email'             => '',
                'filter_customer_group_id' => '',
                'filter_status'            => '',
                'filter_date_added'        => '',
                'filter_ip'                => '',
                'sort'                     => $sort,
                'order'                    => $order,
                'start'          		   => ($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin'),
                'limit'           		   => $this->config->get('config_limit_admin')
            );
            $customerData = $this->model_customer_customer->getCustomers($filter_data);

            $customerWishlist = $this->model_extension_module_customer_wishlist->getAllWishlist();

            $success = $failed = $not_exist = 0;

            if($this->config->get('module_routee_uuid') != "")
            {
                $resultJson = array();
                $customerCartValue = $wishlistInfo = array();

                if($customerData && $customerWishlist)
                {
                    unset($this->session->data['wishlist_not_exists']);
                    foreach($customerData as $k => $customerRow)
                    {
                        $customerID = $customerRow['customer_id'];

                        $customerWishlistData = $this->model_extension_module_customer_wishlist->getWishlist($customerID);
                        if($customerWishlistData)
                        {
                            foreach($customerWishlistData as $k1 => $customerWishlistRow)
                            {
                                unset($customerWishlistRow['date_added']);
                                $wishlistInfo[] = $customerWishlistRow;
                            }
                        }
                    }

                    $customerCartValue["uuid"] = $this->config->get('module_routee_uuid');


                    $customerCartValue['data'][0]["name"] = 'Wishlist';
                    $customerCartValue['data'][0]["description"] = 'Shop Wishlists';
                    $customerCartValue['data'][0]['object'] = $wishlistInfo;

                    //echo '<pre>'; print_r($customerCartValue); exit;

                    $postData = json_encode($customerCartValue);

                    //echo '<pre>'; print_r($postData); exit;
                    $this->sendLogs('event before api call');
                    $ch = curl_init('https://idata.routee.net/api/data');
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $result = curl_exec($ch);
                    $this->sendLogs('event after api call');
                    $this->load->library('routee');
                    $this->routee->write("Mass Wishlist: ".json_encode($customerCartValue)." Result: ".$result);

                    $resultJson = json_decode($result, 1);

                    //echo '<pre>'; print_r($resultJson); exit;

                    if(isset($resultJson))
                    {
                        if(!empty($resultJson['message']))
                        {
                            $module_routee_wishlist_limit1 = $module_routee_wishlist_limit + 1;

                            $this->load->model('setting/setting');

                            $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_wishlist_limit', $module_routee_wishlist_limit1);

                            $resultOutput = sprintf($this->language->get('text_success'), ($customer_total) ? (($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin')) > ($customer_total - $this->config->get('config_limit_admin'))) ? $customer_total : ((($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $customer_total, ceil($customer_total / $this->config->get('config_limit_admin')));
                            $this->session->data['success'] = $resultOutput;
                        }
                        else
                        {
                            $this->session->data['error_warning'] = $this->language->get('text_error');
                        }
                    }
                    else
                    {
                        $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                        $failed++;
                    }
                }
                else
                {
                    //$this->session->data['success'] = $this->language->get('text_all_imported');
                    $this->session->data['wishlist_not_exists'] = 1;
                    $not_exist++;
                }
            }

            $counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);

            if($failed > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_error');
            }
            else if($not_exist > 0)
            {
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
            }
            else
            {
                $this->session->data['success'] = sprintf($this->language->get('text_success'), ($customer_total) ? (($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin')) > ($customer_total - $this->config->get('config_limit_admin'))) ? $customer_total : ((($module_routee_wishlist_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $customer_total, ceil($customer_total / $this->config->get('config_limit_admin')));
            }

            $this->response->redirect($this->url->link('extension/module/routee/wishlist', 'user_token=' . $this->session->data['user_token'], true));
        }catch (Exception $exception){
            $this->sendLogs($exception->getMessage(), $exception);
        }
	}


    public function sendLogs($message, $excep=null)
    {
        try {
            $this->load->library('routeelogs');
            $this->routeelogs->saveLogs('WishlistExport','massdata', $message, $excep);
        }catch (Exception $exception){}

    }


}