<?php
/**
* Log class
*/
class RouteeLogs {

    private $db;
    private $config;
    private $load;
	
	/**
	 * Constructor
	 *
	 * @param	string	$filename
 	*/
	public function __construct($registry) {
        $this->config = $registry->get('config');
        $this->db = $registry->get('db');
        $this->load = $registry->get('load');
	}

    public function eventType($mode) {
        $type = 0;

        switch ($mode) {
            case "auth":
                $type = 1;
                break;
            case "massdata":
                $type = 3;
                break;
            case "events":
                $type = 2;
                break;
        }

        return $type;
    }
	
	/**
     * 
     *
     * @param	string	$message
     */
	public function saveLogs($eventName, $mode, $message, $exception=null) {
        $uuid = $this->config->get('module_routee_uuid');
        $isExported = 0;
        $time = gmdate('d-m-Y H:i:s');
        $shop = $this->config->get('config_url');
        $eventType = $this->eventType($mode);
        $logType = !empty($exception) && $exception->getCode() != 200 ? 0 : 1;
        $message = !empty($exception) ? $exception->getMessage() : $message;
        $code = !empty($exception) ? $exception->getCode() : 200;

        $logData = array(
            'mode' => $mode,
            'event_name' => $eventName,
            'code' => $code,
            'message'=> $message
        );

        $logData = json_encode($logData);

        $query = $this->db->query("INSERT INTO ".DB_PREFIX."routee_shop_logs (store_url, log_type,event_type,log_data,is_exported,created_at) VALUES ('{$shop}','{$logType}','{$eventType}','{$logData}','{$isExported}','{$time}')");

        if (!empty($exception) && $logType == 'failure'){

            $postData = [
                'uuid' => $uuid,
                'siteUrl' => $shop,
                'log_type' => $logType,
                'event_name' => $eventName,
                'log_data' => $logData,
                'platform' => 'Opencartv3',
                'created_at' => $time
            ];

            $ch = curl_init('https://autoforms.routee.net/u001/log.php');
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postData));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $result = curl_exec($ch);
        }

	}
	
	/**
     * 
     *
     */
	public function __destruct() {

	}
}